import math
import time

from fischertechnik.controller.Motor import Motor
from lib.controller import *


degree = None
impulses_per_degree_pan = None
impulses_per_degree_tilt = None


def init_Camera():
    global degree, impulses_per_degree_pan, impulses_per_degree_tilt
    TXT_M_M1_encodermotor.set_speed(int(512), Motor.CCW)
    TXT_M_M1_encodermotor.start_sync()
    TXT_M_M2_encodermotor.set_speed(int(512), Motor.CCW)
    TXT_M_M2_encodermotor.start_sync()
    while (TXT_M_I1_mini_switch.is_open()) or (TXT_M_I2_mini_switch.is_open()):
        if TXT_M_I1_mini_switch.is_closed():
            TXT_M_M1_encodermotor.stop_sync()
        elif TXT_M_I2_mini_switch.is_closed():
            TXT_M_M2_encodermotor.stop_sync()
    TXT_M_M1_encodermotor.set_speed(int(512), Motor.CW)
    TXT_M_M1_encodermotor.set_distance(int(round(87 * impulses_per_degree_pan)))
    TXT_M_M2_encodermotor.set_speed(int(512), Motor.CW)
    TXT_M_M2_encodermotor.set_distance(int(round(78 * impulses_per_degree_tilt)))
    while True:
        if ((not TXT_M_M1_encodermotor.is_running()) and (not TXT_M_M2_encodermotor.is_running())):
            break
        time.sleep(0.010)


def turn_right(degree):
    global impulses_per_degree_pan, impulses_per_degree_tilt
    TXT_M_M1_encodermotor.set_speed(int(512), Motor.CW)
    TXT_M_M1_encodermotor.set_distance(int(round(degree * impulses_per_degree_pan)))
    while True:
        if (not TXT_M_M1_encodermotor.is_running()):
            break
        time.sleep(0.010)


def turn_left(degree):
    global impulses_per_degree_pan, impulses_per_degree_tilt
    TXT_M_M1_encodermotor.set_speed(int(512), Motor.CCW)
    TXT_M_M1_encodermotor.set_distance(int(round(degree * impulses_per_degree_pan)))
    while True:
        if (not TXT_M_M1_encodermotor.is_running()):
            break
        time.sleep(0.010)


def turn_up(degree):
    global impulses_per_degree_pan, impulses_per_degree_tilt
    TXT_M_M2_encodermotor.set_speed(int(512), Motor.CW)
    TXT_M_M2_encodermotor.set_distance(int(round(degree * impulses_per_degree_tilt)))
    while True:
        if (not TXT_M_M2_encodermotor.is_running()):
            break
        time.sleep(0.010)


def turn_down(degree):
    global impulses_per_degree_pan, impulses_per_degree_tilt
    TXT_M_M2_encodermotor.set_speed(int(512), Motor.CCW)
    TXT_M_M2_encodermotor.set_distance(int(round(degree * impulses_per_degree_tilt)))
    while True:
        if (not TXT_M_M2_encodermotor.is_running()):
            break
        time.sleep(0.010)


impulses_per_degree_pan = 10.295
impulses_per_degree_tilt = 5.325
init_Camera()
while True:
    pass
